
/*****************************************************************************/
/*** preforking-servlets.c                                                 ***/
/***                                                                       ***/
/*** Anticipate a certain number of connections to be made by creating the ***/
/*** servlets ahead of time.                                               ***/
/*****************************************************************************/

#include <stdio.h>
#include <errno.h>
#include <sys/signal.h>
/*#include <resolv.h>*/

#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

int ChildCount=0;

/*---------------------------------------------------------------------*/
/*--- sig_child - SIGCHLD                                           ---*/
/*---------------------------------------------------------------------*/
void sig_child(int sig)
{
    wait(0);
    ChildCount--;
}

char *repstr(char *s, char *s1, char *s2)
{
  char *p = (char*) strstr(s, s1);
  size_t l1 = strlen(s1), l2 = strlen(s2);
  
  if (p == NULL) return NULL;
  memmove(p + l2, p + l1, strlen(p + l1) + 1);
  memcpy(p, s2, l2);
  return s;
}


/*---------------------------------------------------------------------*/
/*--- servlet - accept connection and process requests.             ---*/
/*---------------------------------------------------------------------*/
void servlet(int server)
{	

  int bytes;
  char buffer[1024];
  char get[256];
  char *size; 
  char *fsids;
  size_t tmplen = 5;
  int i,j,count = 0;
  char *vals[25];
  char test[1024];
  char *temp;


	for (;;)
	{
		int client = accept(server, 0, 0);
		if ( client > 0 )
		{
			buffer[0]='\0';
			get[0]='\0';

                        bytes = recv(client, buffer, sizeof(buffer), 0);

                       if ( bytes > 0 ) {
                                /*send(client, buffer, bytes, 0);*/
				sscanf(buffer, "GET %s HTTP", get);
    fsids = (char*)malloc(sizeof(fsids)*1024);
				fsids =  (char*) strchr(get, '/'); fsids++; 
				fsids =  (char*) strchr(fsids, '/'); 
				tmplen = strlen(get)-strlen(fsids);
    size = (char*)malloc(sizeof(size)*1024);
				memcpy(size,&get,tmplen);
				size++;
				size[tmplen-1]='\0';
    temp = (char*)malloc(sizeof(temp)*1024);

 				/* subsitutions */
 				while ((temp = repstr(fsids, "%20", " " )) != NULL) {
        			  strcpy(fsids,temp);
				}
 				while ((temp = repstr(fsids, ".2F.", "/" )) != NULL) {
        			  strcpy(fsids,temp);
				}
  /* get the array for the execp  */
  j = 0;
  for (i=0;i<=strlen(fsids);i++){
    vals[count] = (char*)malloc(sizeof(vals)*1024);
    if (i < strlen(fsids) && fsids[i] != ' ') {
     test[j++] = fsids[i];
     test[j] = '\0';
    } else {
     strcpy(vals[count],test);

     j=0;
     count++;
    }
  }  
  vals[count] = '\0';

		}


			/* write out the header */
			write(client, "HTTP/1.0 200 Ok\r\n", strlen("HTTP/1.0 200 Ok\r\n"));
        		write(client, "Server: tyhttpd/fun\r\nConnection: close\r\n", strlen("Server: tyhttpd/fun\r\nConnection: close\r\n"));
        
        		if (size > 0) {
          			write(client, "Accept-Ranges: bytes\r\nContent-Length: ", strlen("Accept-Ranges: bytes\r\nContent-Length: "));
          			write(client, size, strlen(size));
          			write(client, "\r\n", strlen("\r\n"));
       			} 
       			write(client, "Content-type: application/ty\r\n\r\n" , strlen("Content-type: application/ty\r\n\r\n"));

       			close(1); /* close standard output */
        
     			if( dup(client) != 1 ) {
    				perror("error duplicating socket for stdout");
          			exit(1);
        		}    
        
			strcat(vals[0], "/mfs_stream");

       			execvp( vals[0] , vals );
			close(client);
			free (fsids); free(size); free(temp); free(vals);
		}
		else
		{
			perror("accept()");
		}
	}
}

/*---------------------------------------------------------------------*/
/*--- main - set up server, start servlets and keep servelt count up---*/
/*---------------------------------------------------------------------*/
main(int count, char *strings[])
{   
  int sd, pid, portno, max;
	struct sockaddr_in addr;
	struct sigaction act;
  
  
  if (count < 2) {
    fprintf(stderr,"ERROR, usage: %s portnum maxnumconnections\n",strings[0]);
    exit(1);
  }
   	portno = atoi(strings[1]);
        max = atoi(strings[2]);
  
	bzero(&act, sizeof(act));
	act.sa_handler = sig_child;
	act.sa_flags = SA_NOCLDSTOP | SA_RESTART;
	if ( sigaction(SIGCHLD, &act, 0) != 0 )
		perror("sigaction()");
	sd = socket(PF_INET, SOCK_STREAM, 0);
	bzero(&addr, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_port = htons(portno);
	addr.sin_addr.s_addr = INADDR_ANY;
	if ( bind(sd, (struct sockaddr*)&addr, sizeof(addr)) == 0 )
	{
		listen(sd, 15);
	    for (;;)
    	{
        	if ( ChildCount < max )
	        {
    	        if ( (pid = fork()) == 0 ) /*---CHILD---*/
		        servlet(sd);
    	        else if ( pid > 0 )        /*---PARENT---*/
        	        ChildCount++;
	        else                       /*---ERROR---*/
    	        	perror("fork() failed");
        	}
	        else
    	        sleep(1); /*--- OR, sched_yield()---*/
	    }
	}
	else
		perror("bind()");
}

